## lincity-ng 2.10.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21)

set(CMAKE_POLICY_DEFAULT_CMP0077 NEW)
set(X_VCPKG_APPLOCAL_DEPS_INSTALL ON)

project(lincity-ng
	VERSION 2.10.2
	LANGUAGES CXX
	DESCRIPTION "A city simulation game"
	HOMEPAGE_URL "https://github.com/lincity-ng/lincity-ng"
)

list(APPEND CMAKE_MODULE_PATH
	${CMAKE_SOURCE_DIR}/mk/cmake/modules
	${CMAKE_SOURCE_DIR}/mk/cmake/modules/SDL2
)

include(CheckIncludeFiles)
include(GNUInstallDirs)
include(GetGitRevisionDescription)

set(CMAKE_CXX_STANDARD 11 CACHE STRING "C++ standard")
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_FIND_PACKAGE_PREFER_CONFIG TRUE)
find_package(Threads)
find_package(ZLIB REQUIRED)
find_package(SDL2 REQUIRED)
find_package(SDL2_gfx REQUIRED)
find_package(SDL2_image REQUIRED)
find_package(SDL2_mixer REQUIRED)
find_package(SDL2_ttf REQUIRED)
find_package(LibXml2 REQUIRED)
find_package(PhysFS MODULE REQUIRED) # config seems broken, so use module
find_package(LibXslt REQUIRED)

git_describe_working_tree(GIT_TAG_VERSION --match lincity-ng-*)
if(GIT_TAG_VERSION)
	string(SUBSTRING ${GIT_TAG_VERSION} 11 -1 GIT_TAG_VERSION)
else()
	set(GIT_TAG_VERSION ${PROJECT_VERSION}-unknown)
endif()

check_include_files(dirent.h HAVE_DIRENT_H)

set(CMAKE_INSTALL_APPDATADIR ${CMAKE_INSTALL_DATADIR}/${CMAKE_PROJECT_NAME})
set(CMAKE_INSTALL_FULL_APPDATADIR ${CMAKE_INSTALL_FULL_DATADIR}/${CMAKE_PROJECT_NAME})
set(CMAKE_BINARY_BINDIR ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})
set(CMAKE_BINARY_DATADIR ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_DATADIR})
set(CMAKE_BINARY_APPDATADIR ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_APPDATADIR})

add_compile_definitions($<$<CONFIG:Debug>:DEBUG>)

add_subdirectory(src)
add_subdirectory(data ${CMAKE_INSTALL_APPDATADIR})
add_subdirectory(doc)

set_target_properties(lincity-ng PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_BINDIR})
install(TARGETS lincity-ng RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

if (WIN32)
	install(FILES $<TARGET_PDB_FILE:lincity-ng> DESTINATION . OPTIONAL)
endif()


set(CPACK_GENERATOR TGZ ZIP)
set(CPACK_PACKAGE_ICON data/lincity-ng.png)
set(CPACK_PACKAGE_CHECKSUM SHA256)
set(CPACK_RESOURCE_FILE_README README.md)
set(CPACK_SOURCE_GENERATOR TGZ)
set(CPACK_SOURCE_IGNORE_FILES ${CMAKE_BINARY_DIR}/ ${CMAKE_SOURCE_DIR}/\\\\.git/ ${CMAKE_SOURCE_DIR}/build.*/)
include(CPack)

=== data/CMakeLists.txt ===
add_subdirectory(gui)


file(GLOB_RECURSE allDataFiles RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} CONFIGURE_DEPENDS
  fonts/*
  help/*
  images/*
  locale/*
  music/*
  opening/*.scn
  sounds/*
  colour.pal
  lincityconfig.xml
  lincity-ng.desktop
  lincity-ng.png
)

foreach(dataFile ${allDataFiles})
  add_custom_command(
    OUTPUT ${dataFile}
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/${dataFile} ${dataFile}
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${dataFile}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "copying ${dataFile} to build directory"
  )
  cmake_path(GET dataFile PARENT_PATH dataFileDst)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${dataFile} DESTINATION ${CMAKE_INSTALL_APPDATADIR}/${dataFileDst})
endforeach()
add_custom_target(allDataFiles.target DEPENDS ${allDataFiles})
add_dependencies(lincity-ng allDataFiles.target)

# install the desktop file and icon
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/lincity-ng.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/lincity-ng.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/128x128/apps)
# install desktop file as a sym-link
# install(CODE "
#   if(\${CMAKE_INSTALL_PREFIX} EQUAL ${CMAKE_INSTALL_PREFIX})
#   message(STATUS \"installing desktop file: \${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATADIR}/applications/lincity-ng.desktop\\nLinks to: ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_APPDATADIR}/lincity-ng.desktop\")
#   file(MAKE_DIRECTORY \${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATADIR}/applications/)
#   execute_process(COMMAND \${CMAKE_COMMAND} -E create_symlink
#     ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_APPDATADIR}/lincity-ng.desktop
#     \${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATADIR}/applications/lincity-ng.desktop
#   )
# ")


file(GLOB_RECURSE TRANSLATABLE_SOURCES CONFIGURE_DEPENDS
  ${CMAKE_SOURCE_DIR}/src/gui/*.cpp
  ${CMAKE_SOURCE_DIR}/src/gui/*.hpp
  ${CMAKE_SOURCE_DIR}/src/gui/*.h
  ${CMAKE_SOURCE_DIR}/src/lincity/*.cpp
  ${CMAKE_SOURCE_DIR}/src/lincity/*.hpp
  ${CMAKE_SOURCE_DIR}/src/lincity/*.h
  ${CMAKE_SOURCE_DIR}/src/lincity-ng/*.cpp
  ${CMAKE_SOURCE_DIR}/src/lincity-ng/*.hpp
  ${CMAKE_SOURCE_DIR}/src/lincity-ng/*.h
)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/locale)
add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/locale/messages.pot
  COMMAND xgettext --keyword='_:1' --keyword='N_:1' -o ${CMAKE_CURRENT_BINARY_DIR}/locale/messages.pot ${TRANSLATABLE_SOURCES}
  DEPENDS ${TRANSLATABLE_SOURCES}
  COMMENT "generating ${CMAKE_INSTALL_APPDATADIR}/locale/messages.pot"
)
add_custom_target(messages-pot.target DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/locale/messages.pot)
add_dependencies(lincity-ng messages-pot.target)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/locale/messages.pot DESTINATION ${CMAKE_INSTALL_APPDATADIR}/locale)

file(GLOB_RECURSE ALL_GUI_XML RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} CONFIGURE_DEPENDS
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/*.xml
)
list(TRANSFORM ALL_GUI_XML PREPEND ${CMAKE_CURRENT_BINARY_DIR}/)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/locale/gui)
add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/locale/gui/messages.pot
  COMMAND xmlgettext ${CMAKE_CURRENT_BINARY_DIR}/locale/gui/messages.pot ${ALL_GUI_XML}
  DEPENDS ${ALL_GUI_XML} guiXml guiDialogXml
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMENT "generating ${CMAKE_INSTALL_APPDATADIR}/locale/gui/messages.pot"
)
add_custom_target(gui_messages-pot.target DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/locale/gui/messages.pot)
add_dependencies(lincity-ng gui_messages-pot.target)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/locale/gui/messages.pot DESTINATION ${CMAKE_INSTALL_APPDATADIR}/locale/gui)


set(infoFiles
  COPYING
  COPYING-data.txt
  COPYING-fonts.txt
  README.md
  RELNOTES
)
foreach(infoFile ${infoFiles})
  add_custom_command(
    OUTPUT ${infoFile}
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_SOURCE_DIR}/${infoFile} ${infoFile}
    DEPENDS ${CMAKE_SOURCE_DIR}/${infoFile}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "copying ${infoFile} to build directory"
  )
  cmake_path(GET infoFile PARENT_PATH infoFileDst)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${infoFile} DESTINATION ${CMAKE_INSTALL_APPDATADIR}/${infoFileDst})
endforeach()
add_custom_target(infoFiles.target DEPENDS ${infoFiles})
add_dependencies(lincity-ng infoFiles.target)

=== doc/CMakeLists.txt ===

install(FILES lincityconfig.xml DESTINATION ${CMAKE_INSTALL_DOCDIR})
install(FILES userconfig.xml DESTINATION ${CMAKE_INSTALL_DOCDIR})
install(FILES lincity-ng.6 DESTINATION ${CMAKE_INSTALL_MANDIR})

=== src/CMakeLists.txt ===
include_directories(.)

configure_file(config.h.in config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(tinygettext)
add_subdirectory(PhysfsStream)
add_subdirectory(gui)
add_subdirectory(lincity)
add_subdirectory(lincity-ng)
#add_subdirectory(TinyLandGen)
add_subdirectory(tools)

=== data/gui/CMakeLists.txt ===
add_subdirectory(dialogs)

set(guiSourceFiles
  app.xml
  buttonpanel.xml
  creditslist.xml
  credits.xml
  helpwindow.xml
  loadgame.xml
  mainmenu.xml
  messagearea.xml
  minimapswitchbuttons.xml
  minimap.xml
  mps.xml
  newgame.xml
  options.xml
  pbar2nd.xml
  pbar.xml
  piemenu.xml
  savegame.xml
  speedpanel.xml
  too-old.xml
)

foreach(guiSourceFile ${guiSourceFiles})
  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${guiSourceFile}
    COMMAND LibXslt::xsltproc -o ${CMAKE_CURRENT_BINARY_DIR}/${guiSourceFile} ${guiSourceFile}
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${guiSourceFile}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "Convert XML GUI ${guiSourceFile}"
  )

  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${guiSourceFile} DESTINATION ${CMAKE_INSTALL_APPDATADIR}/gui/)
endforeach()

add_custom_target(guiXml DEPENDS ${guiSourceFiles})
add_dependencies(lincity-ng guiXml)

=== src/PhysfsStream/CMakeLists.txt ===
add_library(physfsstream OBJECT
		PhysfsSDL.cpp
		PhysfsSDL.hpp

		PhysfsStream.cpp
		PhysfsStream.hpp

		PhysfsError.hpp
		PhysfsError.cpp
		)
add_library(LinCity::physfsstream ALIAS physfsstream)

target_link_libraries(physfsstream
		PRIVATE
		$<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>
		)

target_include_directories(physfsstream PRIVATE ${PHYSFS_INCLUDE_DIR})
target_link_libraries(physfsstream PRIVATE ${PHYSFS_LIBRARY})

=== src/TinyLandGen/CMakeLists.txt ===
add_executable(TinyLandGen
		ecology.cpp
		ground_sea.cpp
		lakes_rivers.cpp
		lctypes.h
		main.cpp
		save.cpp
		)

target_link_libraries(TinyLandGen
		PRIVATE
		ZLIB::ZLIB
		$<TARGET_NAME_IF_EXISTS:SDL2::SDL2main>
		$<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>
		)

=== src/gui/CMakeLists.txt ===
find_package(OpenGL REQUIRED)

add_library(lincity_gui OBJECT
		Button.cpp
		Child.cpp
		Color.cpp
		Component.cpp
		ComponentFactory.cpp
		ComponentLoader.cpp
		Desktop.cpp
		Document.cpp
		DocumentImage.cpp
		Event.cpp
		FilledRectangle.cpp
		Filter.cpp
		FontManager.cpp
		Gradient.cpp
		Image.cpp
		Panel.cpp
		Paragraph.cpp
		Rect2D.cpp
		ScrollBar.cpp
		ScrollView.cpp
		Style.cpp
		SwitchComponent.cpp
		TableLayout.cpp
		TextureManager.cpp
		TooltipManager.cpp
		Window.cpp
		XmlReader.cpp

		Button.hpp
		Child.hpp
		Color.hpp
		Component.hpp
		ComponentFactory.hpp
		ComponentLoader.hpp
		Desktop.hpp
		Document.hpp
		DocumentElement.hpp
		DocumentImage.hpp
		Event.hpp
		FilledRectangle.hpp
		Filter.hpp
		FontManager.hpp
		Gradient.hpp
		Image.hpp
		Painter.hpp
		Panel.hpp
		Paragraph.hpp
		Rect2D.hpp
		ScrollBar.hpp
		ScrollView.hpp
		Style.hpp
		SwitchComponent.hpp
		TableLayout.hpp
		Texture.hpp
		TextureManager.hpp
		TooltipManager.hpp
		Vector2.hpp
		Window.hpp
		XmlReader.hpp

		callback/Callback.hpp
		callback/CallbackBase.hpp
		callback/Signal.hpp

		PainterGL/PainterGL.cpp
		PainterGL/PainterGL.hpp
		PainterGL/TextureGL.cpp
		PainterGL/TextureGL.hpp
		PainterGL/TextureManagerGL.cpp
		PainterGL/TextureManagerGL.hpp

		PainterSDL/PainterSDL.cpp
		PainterSDL/PainterSDL.hpp
		PainterSDL/TextureSDL.cpp
		PainterSDL/TextureSDL.hpp
		PainterSDL/TextureManagerSDL.cpp
		PainterSDL/TextureManagerSDL.hpp
		)

add_library(LinCity::gui ALIAS lincity_gui)

target_link_libraries(lincity_gui
		PRIVATE
		tinygettext
		LinCity::physfsstream
		$<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>
		SDL2::SDL2_gfx
		LibXml2::LibXml2
		OpenGL::GL
		)

target_include_directories(lincity_gui
		PRIVATE
		${PHYSFS_INCLUDE_DIR}
		PUBLIC
		${LIBXML2_INCLUDE_DIR})
target_link_libraries(lincity_gui PRIVATE ${PHYSFS_LIBRARY})

=== src/lincity-ng/CMakeLists.txt ===
add_executable(lincity-ng
		ButtonInterface.cpp
		ButtonPanel.cpp
		ButtonPanel.hpp
		CheckButton.cpp
		CheckButton.hpp
		Config.cpp
		Config.hpp
		Dialog.cpp
		Dialog.hpp
		lcerror.hpp
		EconomyGraph.cpp
		EconomyGraph.hpp
		ErrorInterface.cpp
		ErrorInterface.hpp
		Game.cpp
		Game.hpp
		GameView.cpp
		GameView.hpp
		getBundleSharePath.cpp
		HelpWindow.cpp
		HelpWindow.hpp
		main.cpp
		main.hpp
		MainLincity.cpp
		MainLincity.hpp
		MainMenu.cpp
		MainMenu.hpp
		MapEdit.cpp
		MapEdit.hpp
		MapPoint.hpp
		MiniMap.cpp
		MiniMap.hpp
		Mps.cpp
		Mps.hpp
		MpsInterface.cpp
		PBar.cpp
		PBar.hpp
		PbarInterface.cpp
		Permutator.cpp
		Permutator.hpp
		readdir.cpp
		readdir.hpp
		ReadPngInterface.cpp
		ScreenInterface.cpp
		ScreenInterface.hpp
		Sound.cpp
		Sound.hpp
		TimerInterface.cpp
		TimerInterface.hpp
		Util.cpp
		Util.hpp
		)

if (WIN32)
	set(APP_ICON_RESOURCE_WINDOWS "${CMAKE_SOURCE_DIR}/contrib/win32/lincity-ng.rc")
	target_sources(lincity-ng PUBLIC ${APP_ICON_RESOURCE_WINDOWS})
endif()

target_link_libraries(lincity-ng
		PRIVATE
		tinygettext
		LinCity::physfsstream
		LinCity::lib
		LinCity::gui
		PUBLIC
		$<TARGET_NAME_IF_EXISTS:SDL2::SDL2main>
		$<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>
		)

target_include_directories(lincity-ng PRIVATE ${PHYSFS_INCLUDE_DIR})
target_link_libraries(lincity-ng PRIVATE ${PHYSFS_LIBRARY})

=== src/lincity/CMakeLists.txt ===
add_subdirectory(modules)

add_library(lincity_lib
		OBJECT

		all_buildings.cpp
		all_buildings.h
		ConstructionCount.cpp
		ConstructionCount.h
		ConstructionManager.cpp
		ConstructionManager.h
		ConstructionRequest.cpp
		ConstructionRequest.h
		engglobs.cpp
		engglobs.h
		engine.cpp
		engine.h
		groups.h
		init_game.cpp
		init_game.h
		lc_locale.cpp
		lc_locale.h
		lclib.cpp
		lclib.h
		lctypes.h
		lin-city.h
		lintypes.cpp
		lintypes.h
		loadsave.cpp
		loadsave.h
		old_ldsvguts.cpp
		old_ldsvguts.h
		simulate.cpp
		simulate.h
		stats.cpp
		stats.h
		sustainable.h
		transport.cpp
		transport.h
		UserOperation.cpp
		UserOperation.h
		Vehicles.cpp
		Vehicles.h
		world.cpp
		world.h
		xmlloadsave.cpp
		xmlloadsave.h
		)

add_library(LinCity::lib ALIAS lincity_lib)

target_link_libraries(lincity_lib
		PRIVATE
		tinygettext
		LinCity::physfsstream
		LinCity::lib_modules
		LinCity::gui
		$<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>
		)

target_include_directories(lincity_lib PRIVATE ${PHYSFS_INCLUDE_DIR})
target_link_libraries(lincity_lib PRIVATE ${PHYSFS_LIBRARY})

if (NOT WIN32)
	add_compile_definitions(lincity_lib PRIVATE DEFAULT_LIBDIR="lib")    # TODO
endif()

=== src/tinygettext/CMakeLists.txt ===
add_library(tinygettext
		findlocale.cpp
		findlocale.hpp
		gettext.hpp
		tinygettext.cpp
		tinygettext.hpp
		)

target_link_libraries(tinygettext
		PRIVATE
		$<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>
		)

=== src/tools/CMakeLists.txt ===
add_subdirectory(xmlgettext)

=== debian/changelog ===
lincity-ng (2.10.2-1) unstable; urgency=medium

  * Team Upload
  * New upstream version 2.10.2 (Closes: #1068636)

 -- Alexandre Detiste <tchet@debian.org>  Wed, 24 Apr 2024 14:51:06 +0200

lincity-ng (2.10.1-2) unstable; urgency=medium

  * Team Upload
  * put back icon at it's previous place: this rightfully
    triggers a piuparts error with a chance of 1/2.
  * set "Rules-Requires-Root: no"
  * janitor: add upstream metadata

 -- Alexandre Detiste <tchet@debian.org>  Wed, 03 Apr 2024 21:10:18 +0200

lincity-ng (2.10.1-1) unstable; urgency=medium

  * Team Upload
  * New upstream version 2.10.1
  * replace old autoconf+jam build with modern CMake (Closes: #1064228)

 -- Alexandre Detiste <tchet@debian.org>  Mon, 01 Apr 2024 18:58:18 +0200

lincity-ng (2.9.0-1) unstable; urgency=medium

  * Team Upload
  * switch to libSDL2 (Closes: #1038476)
  * replace pkg-config by pkgconf

 -- Alexandre Detiste <tchet@debian.org>  Sun, 18 Feb 2024 19:54:57 +0100

lincity-ng (2.9~git20150314-5) unstable; urgency=medium

  [ Reiner Herrmann ]
  * Update and fix watch file.

  [ Markus Koschany ]
  * Declare compliance with Debian Policy 4.6.2.

 -- Markus Koschany <apo@debian.org>  Sat, 25 Feb 2023 18:05:29 +0100

=== debian/control ===
Source: lincity-ng
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Markus Koschany <apo@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libphysfs-dev,
 libsdl2-gfx-dev,
 libsdl2-image-dev,
 libsdl2-mixer-dev,
 libsdl2-ttf-dev,
 libsdl2-dev,
 libxml2-dev,
 libxslt1-dev,
 pkgconf,
 xsltproc,
 zlib1g-dev
Rules-Requires-Root: no
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/games-team/lincity-ng.git
Vcs-Browser: https://salsa.debian.org/games-team/lincity-ng
Homepage: https://github.com/lincity-ng/lincity-ng/

Package: lincity-ng
Architecture: any
Depends:
 lincity-ng-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: City simulator game with polished graphics
 LinCity-NG is a City Simulation Game. It is a polished and improved
 version of the old LinCity game:
 You are required to build and maintain a city. You must feed, house,
 provide jobs and goods for your residents. You can build a sustainable
 economy with the help of renewable energy and recycling, or you can go for
 broke and build rockets to escape from a pollution ridden and resource
 starved planet, it's up to you. Due to the finite resources available in any
 one place, this is not a game that you can leave for long periods of time.
 This game is similar to the commercial simulation game with a similar
 name.

Package: lincity-ng-data
Architecture: all
Multi-Arch: foreign
Breaks: lincity-ng (<< 2.10.2-1~)
Depends:
 fonts-dejavu,
 ${misc:Depends}
Suggests:
 lincity-ng
Description: Media files for the city simulator game LinCity-NG
 LinCity-NG is a City Simulation Game. It is a polished and improved
 version of the old LinCity game:
 You are required to build and maintain a city. You must feed, house,
 provide jobs and goods for your residents. You can build a sustainable
 economy with the help of renewable energy and recycling, or you can go for
 broke and build rockets to escape from a pollution ridden and resource
 starved planet, it's up to you. Due to the finite resources available in any
 one place, this is not a game that you can leave for long periods of time.
 This game is similar to the commercial simulation game with a similar
 name.
 .
 This package contains the architecture independent game media files.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/pkg-info.mk

%:
	dh $@

# BUG: GIT_ATG_VERSION & CMAKE_INSTALL_APPDATADIR
#      are not taken into account (BINDIR well)
override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_BINDIR=/usr/games/ \
		-DGIT_TAG_VERSION=$(DEB_VERSION) \
		-DCMAKE_INSTALL_APPDATADIR=/usr/share/games

override_dh_installchangelogs:
	dh_installchangelogs RELNOTES

## lincity-ng 2.11.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,8 +4,8 @@
 set(X_VCPKG_APPLOCAL_DEPS_INSTALL ON)
 
 project(lincity-ng
-	VERSION 2.10.2
-	LANGUAGES CXX
+	VERSION 2.11.0
+	LANGUAGES CXX C
 	DESCRIPTION "A city simulation game"
 	HOMEPAGE_URL "https://github.com/lincity-ng/lincity-ng"
 )
@@ -24,6 +24,7 @@
 set(CMAKE_CXX_EXTENSIONS OFF)
 
 set(CMAKE_FIND_PACKAGE_PREFER_CONFIG TRUE)
+
 find_package(Threads)
 find_package(ZLIB REQUIRED)
 find_package(SDL2 REQUIRED)
@@ -32,14 +33,32 @@
 find_package(SDL2_mixer REQUIRED)
 find_package(SDL2_ttf REQUIRED)
 find_package(LibXml2 REQUIRED)
+# Prevent linking unneded libraries from LibXml2. see https://trac.macports.org/ticket/59436
+set_target_properties(LibXml2::LibXml2 PROPERTIES INTERFACE_LINK_LIBRARIES "")
 find_package(PhysFS MODULE REQUIRED) # config seems broken, so use module
-find_package(LibXslt REQUIRED)
 
-git_describe_working_tree(GIT_TAG_VERSION --match lincity-ng-*)
-if(GIT_TAG_VERSION)
-	string(SUBSTRING ${GIT_TAG_VERSION} 11 -1 GIT_TAG_VERSION)
+# find_package(LibXslt NO_CMAKE_FIND_ROOT_PATH)
+# The libxslt find module is broken when cross compiling because it looks in the
+# target environment instead of the host. The workaround is to find only the
+# xsltproc program.
+if(NOT TARGET LibXslt::xsltproc)
+	if(NOT DEFINED LIBXSLT_XSLTPROC_EXECUTABLE)
+		find_program(LIBXSLT_XSLTPROC_EXECUTABLE NAMES xsltproc REQUIRED)
+	endif()
+	if(DEFINED LIBXSLT_XSLTPROC_EXECUTABLE)
+		add_executable(LibXslt::xsltproc IMPORTED)
+		set_target_properties(LibXslt::xsltproc PROPERTIES IMPORTED_LOCATION "${LIBXSLT_XSLTPROC_EXECUTABLE}")
+	endif()
+endif()
+
+find_program(GETTEXT_XGETTEXT NAMES xgettext)
+find_program(INCLUDE_WHAT_YOU_USE NAMES include-what-you-use)
+
+git_describe_working_tree(FULL_PROJECT_VERSION --match lincity-ng-*)
+if(FULL_PROJECT_VERSION)
+	string(SUBSTRING ${FULL_PROJECT_VERSION} 11 -1 FULL_PROJECT_VERSION)
 else()
-	set(GIT_TAG_VERSION ${PROJECT_VERSION}-unknown)
+	set(FULL_PROJECT_VERSION ${PROJECT_VERSION}-unknown)
 endif()
 
 check_include_files(dirent.h HAVE_DIRENT_H)
@@ -51,17 +70,54 @@
 set(CMAKE_BINARY_APPDATADIR ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_APPDATADIR})
 
 add_compile_definitions($<$<CONFIG:Debug>:DEBUG>)
+add_compile_options("-fmacro-prefix-map=${CMAKE_SOURCE_DIR}=.")
+if(UNIX)
+	add_compile_definitions("UNIX")
+endif()
+if(WIN32)
+	add_compile_definitions("WIN32")
+endif()
+if(APPLE)
+	add_compile_definitions("APPLE")
+endif()
+
+if(NOT CMAKE_CROSSCOMPILING AND INCLUDE_WHAT_YOU_USE)
+	set(CMAKE_CXX_INCLUDE_WHAT_YOU_USE
+		"${INCLUDE_WHAT_YOU_USE};-w;-Xiwyu;--mapping_file=${CMAKE_SOURCE_DIR}/iwyu-mapping")
+	set(CMAKE_C_INCLUDE_WHAT_YOU_USE ${CMAKE_CXX_INCLUDE_WHAT_YOU_USE})
+endif()
 
 add_subdirectory(src)
 add_subdirectory(data ${CMAKE_INSTALL_APPDATADIR})
 add_subdirectory(doc)
 
 set_target_properties(lincity-ng PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_BINDIR})
-install(TARGETS lincity-ng RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+install(TARGETS lincity-ng
+	RUNTIME_DEPENDENCY_SET dll_dependencies
+	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+)
+if(WIN32)
+	# from https://gitlab.kitware.com/cmake/cmake/-/issues/20753#note_870046
+	if(MINGW AND CMAKE_CROSSCOMPILING)
+		# workaround for crosscompiling on linux/mingw for windows
+		install(CODE [[
+			set(CMAKE_GET_RUNTIME_DEPENDENCIES_PLATFORM "windows+pe")
+			set(CMAKE_GET_RUNTIME_DEPENDENCIES_TOOL "objdump")
+			set(CMAKE_GET_RUNTIME_DEPENDENCIES_COMMAND "${CMAKE_OBJDUMP}")
+			# file(WRITE "objdump_unix2dos.sh" "${CMAKE_OBJDUMP} $@ | unix2dos")
+			# file(CHMOD "objdump_unix2dos.sh" PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE)
+		]])
+	endif()
 
-if (WIN32)
-	install(FILES $<TARGET_PDB_FILE:lincity-ng> DESTINATION . OPTIONAL)
+	install(RUNTIME_DEPENDENCY_SET dll_dependencies
+		DIRECTORIES ${CMAKE_FIND_ROOT_PATH}/bin  # dll's from mingw
+		UNRESOLVED_DEPENDENCIES_VAR DUMMY  # hacky!
+		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+	)
 endif()
+# if (WIN32)
+# 	install(FILES $<TARGET_PDB_FILE:lincity-ng> DESTINATION . OPTIONAL)
+# endif()
 
 
 set(CPACK_GENERATOR TGZ ZIP)
@@ -70,4 +126,5 @@
 set(CPACK_RESOURCE_FILE_README README.md)
 set(CPACK_SOURCE_GENERATOR TGZ)
 set(CPACK_SOURCE_IGNORE_FILES ${CMAKE_BINARY_DIR}/ ${CMAKE_SOURCE_DIR}/\\\\.git/ ${CMAKE_SOURCE_DIR}/build.*/)
+set(CPACK_PACKAGE_VERSION ${FULL_PROJECT_VERSION})
 include(CPack)

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -58,13 +58,13 @@
 file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/locale)
 add_custom_command(
   OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/locale/messages.pot
-  COMMAND xgettext --keyword='_:1' --keyword='N_:1' -o ${CMAKE_CURRENT_BINARY_DIR}/locale/messages.pot ${TRANSLATABLE_SOURCES}
+  COMMAND ${GETTEXT_XGETTEXT} --keyword='_:1' --keyword='N_:1' -o ${CMAKE_CURRENT_BINARY_DIR}/locale/messages.pot ${TRANSLATABLE_SOURCES}
   DEPENDS ${TRANSLATABLE_SOURCES}
   COMMENT "generating ${CMAKE_INSTALL_APPDATADIR}/locale/messages.pot"
 )
 add_custom_target(messages-pot.target DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/locale/messages.pot)
-add_dependencies(lincity-ng messages-pot.target)
-install(FILES ${CMAKE_CURRENT_BINARY_DIR}/locale/messages.pot DESTINATION ${CMAKE_INSTALL_APPDATADIR}/locale)
+# add_dependencies(lincity-ng messages-pot.target)
+# install(FILES ${CMAKE_CURRENT_BINARY_DIR}/locale/messages.pot DESTINATION ${CMAKE_INSTALL_APPDATADIR}/locale)
 
 file(GLOB_RECURSE ALL_GUI_XML RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} CONFIGURE_DEPENDS
   ${CMAKE_CURRENT_SOURCE_DIR}/gui/*.xml
@@ -79,8 +79,10 @@
   COMMENT "generating ${CMAKE_INSTALL_APPDATADIR}/locale/gui/messages.pot"
 )
 add_custom_target(gui_messages-pot.target DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/locale/gui/messages.pot)
-add_dependencies(lincity-ng gui_messages-pot.target)
-install(FILES ${CMAKE_CURRENT_BINARY_DIR}/locale/gui/messages.pot DESTINATION ${CMAKE_INSTALL_APPDATADIR}/locale/gui)
+# add_dependencies(lincity-ng gui_messages-pot.target)
+# install(FILES ${CMAKE_CURRENT_BINARY_DIR}/locale/gui/messages.pot DESTINATION ${CMAKE_INSTALL_APPDATADIR}/locale/gui)
+
+add_custom_target(messages.pot DEPENDS messages-pot.target gui_messages-pot.target)
 
 
 set(infoFiles
@@ -88,8 +90,11 @@
   COPYING-data.txt
   COPYING-fonts.txt
   README.md
-  RELNOTES
+  CHANGELOG.md
 )
+if(WIN32)
+  set(infoFiles ${infoFiles} COPYING-dll.txt)
+endif()
 foreach(infoFile ${infoFiles})
   add_custom_command(
     OUTPUT ${infoFile}

=== debian/changelog ===
lincity-ng (2.11.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.7.0 (routine-update)

 -- Alexandre Detiste <tchet@debian.org>  Thu, 27 Jun 2024 07:26:14 +0200

=== debian/control ===
--- 
+++ 
@@ -19,7 +19,7 @@
  xsltproc,
  zlib1g-dev
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/games-team/lincity-ng.git
 Vcs-Browser: https://salsa.debian.org/games-team/lincity-ng
 Homepage: https://github.com/lincity-ng/lincity-ng/

## lincity-ng 2.11.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 set(X_VCPKG_APPLOCAL_DEPS_INSTALL ON)
 
 project(lincity-ng
-	VERSION 2.11.0
+	VERSION 2.11.1
 	LANGUAGES CXX C
 	DESCRIPTION "A city simulation game"
 	HOMEPAGE_URL "https://github.com/lincity-ng/lincity-ng"

=== src/PhysfsStream/CMakeLists.txt ===
add_library(physfsstream STATIC
		PhysfsSDL.cpp
		PhysfsSDL.hpp

		PhysfsStream.cpp
		PhysfsStream.hpp

		PhysfsError.hpp
		PhysfsError.cpp
)
add_library(LinCity::physfsstream ALIAS physfsstream)

target_link_libraries(physfsstream
	PUBLIC
	$<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>
	${PHYSFS_LIBRARY}
)

target_include_directories(physfsstream
	PUBLIC
	${PHYSFS_INCLUDE_DIR}
)

include_directories(.)

=== debian/changelog ===
lincity-ng (2.11.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.11.1

 -- Alexandre Detiste <tchet@debian.org>  Tue, 23 Jul 2024 01:49:55 +0200

## lincity-ng 2.11.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 set(X_VCPKG_APPLOCAL_DEPS_INSTALL ON)
 
 project(lincity-ng
-	VERSION 2.11.1
+	VERSION 2.11.2
 	LANGUAGES CXX C
 	DESCRIPTION "A city simulation game"
 	HOMEPAGE_URL "https://github.com/lincity-ng/lincity-ng"
@@ -123,7 +123,7 @@
 set(CPACK_GENERATOR TGZ ZIP)
 set(CPACK_PACKAGE_ICON data/lincity-ng.png)
 set(CPACK_PACKAGE_CHECKSUM SHA256)
-set(CPACK_RESOURCE_FILE_README README.md)
+set(CPACK_RESOURCE_FILE_README ${CMAKE_SOURCE_DIR}/README.md)
 set(CPACK_SOURCE_GENERATOR TGZ)
 set(CPACK_SOURCE_IGNORE_FILES ${CMAKE_BINARY_DIR}/ ${CMAKE_SOURCE_DIR}/\\\\.git/ ${CMAKE_SOURCE_DIR}/build.*/)
 set(CPACK_PACKAGE_VERSION ${FULL_PROJECT_VERSION})

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,8 @@
 file(GLOB_RECURSE allDataFiles RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} CONFIGURE_DEPENDS
   fonts/*
   help/*
-  images/*
+  images/*.png
+  images/*.xml
   locale/*
   music/*
   opening/*.scn

=== src/gui/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 find_package(OpenGL REQUIRED)
 
-add_library(lincity_gui OBJECT
+add_library(lincity_gui  STATIC
 		Button.cpp
 		Child.cpp
 		Color.cpp
@@ -26,7 +26,9 @@
 		TableLayout.cpp
 		TextureManager.cpp
 		TooltipManager.cpp
+		Vector2.cpp
 		Window.cpp
+		WindowManager.cpp
 		XmlReader.cpp
 
 		Button.hpp
@@ -59,6 +61,7 @@
 		TooltipManager.hpp
 		Vector2.hpp
 		Window.hpp
+		WindowManager.hpp
 		XmlReader.hpp
 
 		callback/Callback.hpp
@@ -83,14 +86,17 @@
 add_library(LinCity::gui ALIAS lincity_gui)
 
 target_link_libraries(lincity_gui
+		PUBLIC
+		LibXml2::LibXml2
+		$<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>
+		$<IF:$<TARGET_EXISTS:SDL2_ttf::SDL2_ttf>,SDL2_ttf::SDL2_ttf,SDL2_ttf::SDL2_ttf-static>
+		OpenGL::GL
 		PRIVATE
 		tinygettext
 		LinCity::physfsstream
-		$<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>
 		SDL2::SDL2_gfx
-		LibXml2::LibXml2
-		OpenGL::GL
-		)
+		${PHYSFS_LIBRARY}
+)
 
 target_include_directories(lincity_gui
 		PRIVATE
@@ -98,3 +104,5 @@
 		PUBLIC
 		${LIBXML2_INCLUDE_DIR})
 target_link_libraries(lincity_gui PRIVATE ${PHYSFS_LIBRARY})
+
+include_directories(.)

=== src/lincity-ng/CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,6 @@
 		Config.hpp
 		Dialog.cpp
 		Dialog.hpp
-		lcerror.hpp
 		EconomyGraph.cpp
 		EconomyGraph.hpp
 		ErrorInterface.cpp
@@ -20,6 +19,8 @@
 		getBundleSharePath.cpp
 		HelpWindow.cpp
 		HelpWindow.hpp
+		lc_error.c
+		lc_error.h
 		main.cpp
 		main.hpp
 		MainLincity.cpp
@@ -41,7 +42,6 @@
 		Permutator.hpp
 		readdir.cpp
 		readdir.hpp
-		ReadPngInterface.cpp
 		ScreenInterface.cpp
 		ScreenInterface.hpp
 		Sound.cpp
@@ -50,7 +50,7 @@
 		TimerInterface.hpp
 		Util.cpp
 		Util.hpp
-		)
+)
 
 if (WIN32)
 	set(APP_ICON_RESOURCE_WINDOWS "${CMAKE_SOURCE_DIR}/contrib/win32/lincity-ng.rc")
@@ -58,15 +58,19 @@
 endif()
 
 target_link_libraries(lincity-ng
-		PRIVATE
-		tinygettext
-		LinCity::physfsstream
-		LinCity::lib
-		LinCity::gui
-		PUBLIC
-		$<TARGET_NAME_IF_EXISTS:SDL2::SDL2main>
-		$<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>
-		)
+	PUBLIC
+	LinCity::lib
+	LinCity::gui
+	$<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>
+	$<IF:$<TARGET_EXISTS:SDL2_mixer::SDL2_mixer>,SDL2_mixer::SDL2_mixer,SDL2_mixer::SDL2_mixer-static>
+	PRIVATE
+	tinygettext
+	LinCity::physfsstream
+	$<TARGET_NAME_IF_EXISTS:SDL2::SDL2main>
+	$<IF:$<TARGET_EXISTS:SDL2_image::SDL2_image>,SDL2_image::SDL2_image,SDL2_image::SDL2_image-static>
+)
 
 target_include_directories(lincity-ng PRIVATE ${PHYSFS_INCLUDE_DIR})
 target_link_libraries(lincity-ng PRIVATE ${PHYSFS_LIBRARY})
+
+include_directories(.)

=== debian/changelog ===
lincity-ng (2.11.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.11.2

 -- Alexandre Detiste <tchet@debian.org>  Sat, 28 Sep 2024 16:55:54 +0200

## lincity-ng 2.12.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 set(X_VCPKG_APPLOCAL_DEPS_INSTALL ON)
 
 project(lincity-ng
-	VERSION 2.11.2
+	VERSION 2.12.0
 	LANGUAGES CXX C
 	DESCRIPTION "A city simulation game"
 	HOMEPAGE_URL "https://github.com/lincity-ng/lincity-ng"
@@ -83,13 +83,14 @@
 
 if(NOT CMAKE_CROSSCOMPILING AND INCLUDE_WHAT_YOU_USE)
 	set(CMAKE_CXX_INCLUDE_WHAT_YOU_USE
-		"${INCLUDE_WHAT_YOU_USE};-w;-Xiwyu;--mapping_file=${CMAKE_SOURCE_DIR}/iwyu-mapping")
+	"${INCLUDE_WHAT_YOU_USE};-w;-Xiwyu;--mapping_file=${CMAKE_SOURCE_DIR}/iwyu.map")
 	set(CMAKE_C_INCLUDE_WHAT_YOU_USE ${CMAKE_CXX_INCLUDE_WHAT_YOU_USE})
 endif()
 
 add_subdirectory(src)
 add_subdirectory(data ${CMAKE_INSTALL_APPDATADIR})
 add_subdirectory(doc)
+add_subdirectory(external)
 
 set_target_properties(lincity-ng PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_BINDIR})
 install(TARGETS lincity-ng
@@ -127,4 +128,5 @@
 set(CPACK_SOURCE_GENERATOR TGZ)
 set(CPACK_SOURCE_IGNORE_FILES ${CMAKE_BINARY_DIR}/ ${CMAKE_SOURCE_DIR}/\\\\.git/ ${CMAKE_SOURCE_DIR}/build.*/)
 set(CPACK_PACKAGE_VERSION ${FULL_PROJECT_VERSION})
+set(CPACK_STRIP_FILES TRUE)
 include(CPack)

=== data/CMakeLists.txt ===
add_subdirectory(gui)
add_subdirectory(locale)

# set_property(GLOBAL PROPERTY TARGET_MESSAGES OFF)

function(copy_data_file data_file src_loc dst_loc)
  set(build_path ${CMAKE_BINARY_DIR}/${dst_loc}/${data_file})
  set(install_path ${dst_loc}/${data_file})
  add_custom_command(
    OUTPUT ${build_path}
    COMMAND ${CMAKE_COMMAND} -E copy ${src_loc}/${data_file} ${build_path}
    DEPENDS ${src_loc}/${data_file}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "copying ${data_file} to build directory"
  )
  if(ARGC GREATER_EQUAL 4)
    list(APPEND ${ARGV3} ${build_path})
    set(${ARGV3} ${${ARGV3}} PARENT_SCOPE)
  else()
    string(REPLACE "/" "_" tmp_target ${build_path})
    add_custom_target(${tmp_target} DEPENDS ${build_path})
    add_dependencies(lincity-ng ${tmp_target})
  endif()
  cmake_path(GET install_path PARENT_PATH install_path_parent)
  install(FILES ${build_path} DESTINATION ${install_path_parent})
endfunction(copy_data_file)

file(GLOB_RECURSE allDataFiles RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} CONFIGURE_DEPENDS
  fonts/*
  help/*
  images/*.png
  images/*.xml
  locale/*.po
  music/*
  opening/*.scn.gz
  sounds/*
  lincityconfig.xml
)
foreach(dataFile ${allDataFiles})
  copy_data_file(${dataFile} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_INSTALL_APPDATADIR} data_files_out)
endforeach()

set(infoFiles
  CHANGELOG.md
  COPYING
  COPYING-data.txt
  COPYING-fonts.txt
  README.md
)
if(WIN32)
  set(infoFiles ${infoFiles} COPYING-dll.txt)
endif()
foreach(infoFile ${infoFiles})
  copy_data_file(${infoFile} ${CMAKE_SOURCE_DIR} ${CMAKE_INSTALL_DOCDIR} data_files_out)
endforeach()

copy_data_file(lincity-ng.desktop ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_INSTALL_DATADIR}/applications data_files_out)
copy_data_file(lincity-ng.png ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_INSTALL_DATADIR}/icons/hicolor/128x128/apps data_files_out)

add_custom_target(data-files.target DEPENDS ${data_files_out})
add_dependencies(lincity-ng data-files.target)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,4 @@
+
 include_directories(.)
 
 configure_file(config.h.in config.h)

=== data/locale/CMakeLists.txt ===
add_custom_target(messages.pot DEPENDS messages-pot.target gui_messages-pot.target)

file(RELATIVE_PATH CURRENT_BINARY_DIR_REL
  ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_BINARY_DIR})


file(GLOB_RECURSE TRANSLATABLE_SOURCES CONFIGURE_DEPENDS
  ${CMAKE_SOURCE_DIR}/src/gui/*.cpp
  ${CMAKE_SOURCE_DIR}/src/gui/*.hpp
  ${CMAKE_SOURCE_DIR}/src/gui/*.h
  ${CMAKE_SOURCE_DIR}/src/lincity/*.cpp
  ${CMAKE_SOURCE_DIR}/src/lincity/*.hpp
  ${CMAKE_SOURCE_DIR}/src/lincity/*.h
  ${CMAKE_SOURCE_DIR}/src/lincity-ng/*.cpp
  ${CMAKE_SOURCE_DIR}/src/lincity-ng/*.hpp
  ${CMAKE_SOURCE_DIR}/src/lincity-ng/*.h
)
add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/messages.pot
  COMMAND ${GETTEXT_XGETTEXT} --keyword='_:1' --keyword='N_:1' -o ${CMAKE_CURRENT_BINARY_DIR}/messages.pot ${TRANSLATABLE_SOURCES}
  DEPENDS ${TRANSLATABLE_SOURCES}
  COMMENT "generating ${CURRENT_BINARY_DIR_REL}/messages.pot"
)
add_custom_target(messages-pot.target
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/messages.pot)


file(GLOB_RECURSE TRANSLATABLE_GUI RELATIVE ${CMAKE_SOURCE_DIR}/data/gui CONFIGURE_DEPENDS
  ${CMAKE_SOURCE_DIR}/data/gui/*.xml
)
list(TRANSFORM TRANSLATABLE_GUI PREPEND ${CMAKE_BINARY_APPDATADIR}/gui/)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/gui)
add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/gui/messages.pot
  COMMAND xmlgettext ${CMAKE_CURRENT_BINARY_DIR}/gui/messages.pot ${TRANSLATABLE_GUI}
  DEPENDS ${TRANSLATABLE_GUI} guiXml guiDialogXml
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMENT "generating ${CURRENT_BINARY_DIR_REL}/gui/messages.pot"
)
add_custom_target(gui_messages-pot.target DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gui/messages.pot)

=== src/gui/CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,7 @@
 
 add_library(lincity_gui  STATIC
 		Button.cpp
+		CheckButton.cpp
 		Child.cpp
 		Color.cpp
 		Component.cpp
@@ -18,6 +19,7 @@
 		Image.cpp
 		Panel.cpp
 		Paragraph.cpp
+		RadioButtonGroup.cpp
 		Rect2D.cpp
 		ScrollBar.cpp
 		ScrollView.cpp
@@ -32,6 +34,7 @@
 		XmlReader.cpp
 
 		Button.hpp
+		CheckButton.hpp
 		Child.hpp
 		Color.hpp
 		Component.hpp
@@ -50,9 +53,11 @@
 		Painter.hpp
 		Panel.hpp
 		Paragraph.hpp
+		RadioButtonGroup.hpp
 		Rect2D.hpp
 		ScrollBar.hpp
 		ScrollView.hpp
+		Signal.hpp
 		Style.hpp
 		SwitchComponent.hpp
 		TableLayout.hpp
@@ -63,10 +68,6 @@
 		Window.hpp
 		WindowManager.hpp
 		XmlReader.hpp
-
-		callback/Callback.hpp
-		callback/CallbackBase.hpp
-		callback/Signal.hpp
 
 		PainterGL/PainterGL.cpp
 		PainterGL/PainterGL.hpp
@@ -93,7 +94,7 @@
 		OpenGL::GL
 		PRIVATE
 		tinygettext
-		LinCity::physfsstream
+		physfsrwops
 		SDL2::SDL2_gfx
 		${PHYSFS_LIBRARY}
 )

=== src/lincity-ng/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,6 @@
 add_executable(lincity-ng
-		ButtonInterface.cpp
 		ButtonPanel.cpp
 		ButtonPanel.hpp
-		CheckButton.cpp
-		CheckButton.hpp
 		Config.cpp
 		Config.hpp
 		Dialog.cpp
@@ -65,6 +62,7 @@
 	$<IF:$<TARGET_EXISTS:SDL2_mixer::SDL2_mixer>,SDL2_mixer::SDL2_mixer,SDL2_mixer::SDL2_mixer-static>
 	PRIVATE
 	tinygettext
+	physfsrwops
 	LinCity::physfsstream
 	$<TARGET_NAME_IF_EXISTS:SDL2::SDL2main>
 	$<IF:$<TARGET_EXISTS:SDL2_image::SDL2_image>,SDL2_image::SDL2_image,SDL2_image::SDL2_image-static>

=== src/lincity/CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,10 @@
 add_subdirectory(modules)
 
-add_library(lincity_lib
-		OBJECT
-
+add_library(lincity_lib  STATIC
 		all_buildings.cpp
 		all_buildings.h
+		commodities.cpp
+		commodities.hpp
 		ConstructionCount.cpp
 		ConstructionCount.h
 		ConstructionManager.cpp
@@ -30,6 +30,8 @@
 		loadsave.h
 		old_ldsvguts.cpp
 		old_ldsvguts.h
+		resources.cpp
+		resources.hpp
 		simulate.cpp
 		simulate.h
 		stats.cpp
@@ -45,17 +47,19 @@
 		world.h
 		xmlloadsave.cpp
 		xmlloadsave.h
-		)
+)
 
 add_library(LinCity::lib ALIAS lincity_lib)
 
 target_link_libraries(lincity_lib
+		PUBLIC
+		LinCity::lib_modules
+		$<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>
+		ZLIB::ZLIB
 		PRIVATE
 		tinygettext
 		LinCity::physfsstream
-		LinCity::lib_modules
 		LinCity::gui
-		$<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>
 		)
 
 target_include_directories(lincity_lib PRIVATE ${PHYSFS_INCLUDE_DIR})
@@ -64,3 +68,5 @@
 if (NOT WIN32)
 	add_compile_definitions(lincity_lib PRIVATE DEFAULT_LIBDIR="lib")    # TODO
 endif()
+
+include_directories(.)

=== src/tinygettext/CMakeLists.txt ===
add_library(tinygettext STATIC
		findlocale.cpp
		findlocale.hpp
		gettext.hpp
		tinygettext.cpp
		tinygettext.hpp
)

target_link_libraries(tinygettext
		PRIVATE
		LinCity::physfsstream
		$<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>
)

include_directories(.)

=== data/gui/dialogs/CMakeLists.txt ===
set(guiDialogSourceFiles
  allgone.xml
  blacksmithup.xml
  bulldoze_monument_yn.xml
  bulldoze_river_yn.xml
  bulldoze_shanty_yn.xml
  coalmineup.xml
  coalpowerup.xml
  coal_survey_yn.xml
  cricketup.xml
  firestationup.xml
  fire.xml
  gamestats.xml
  healthup.xml
  hvindustryup.xml
  import-exportup.xml
  launch-evac.xml
  launch-fail.xml
  launch-gone.xml
  launch-good.xml
  launch_rocket_yn.xml
  ltindustryup.xml
  millup.xml
  mod_wind_up.xml
  nobull-tip.xml
  no-credit-parkland.xml
  no-credit-recycle.xml
  no-credit-rocket.xml
  no-credit-solar-power.xml
  no-credit-university.xml
  parkup.xml
  portdialog.xml
  potteryup.xml
  railwayup.xml
  recycleup.xml
  riverup.xml
  roadup.xml
  rocketup.xml
  schoolup.xml
  solarpowerup.xml
  sustain.xml
  tradedialog.xml
  universityup.xml
  warning.xml
  windmillup.xml
)

foreach(guiDialogSourceFile ${guiDialogSourceFiles})
  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${guiDialogSourceFile}
    COMMAND LibXslt::xsltproc -o ${CMAKE_CURRENT_BINARY_DIR}/${guiDialogSourceFile} ${guiDialogSourceFile}
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${guiDialogSourceFile}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "Converting dialogs/${guiDialogSourceFile}"
  )

  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${guiDialogSourceFile} DESTINATION ${CMAKE_INSTALL_APPDATADIR}/gui/dialogs/)
endforeach()

add_custom_target(guiDialogXml DEPENDS ${guiDialogSourceFiles})
add_dependencies(lincity-ng guiDialogXml)

=== src/lincity/modules/CMakeLists.txt ===
add_library(lincity_lib_modules  STATIC
		all_modules.cpp
		all_modules.h
		blacksmith.cpp
		blacksmith.h
		coal_power.cpp
		coal_power.h
		coalmine.cpp
		coalmine.h
		commune.cpp
		commune.h
		cricket.cpp
		cricket.h
		fire.cpp
		fire.h
		firestation.cpp
		firestation.h
		health_centre.cpp
		health_centre.h
		heavy_industry.cpp
		heavy_industry.h
		light_industry.cpp
		light_industry.h
		market.cpp
		market.h
		mill.cpp
		mill.h
		modules.h
		modules_interfaces.h
		monument.cpp
		monument.h
		oremine.cpp
		oremine.h
		organic_farm.cpp
		organic_farm.h
		parkland.cpp
		parkland.h
		port.cpp
		port.h
		pottery.cpp
		pottery.h
		power_line.cpp
		power_line.h
		recycle.cpp
		recycle.h
		residence.cpp
		residence.h
		rocket_pad.cpp
		rocket_pad.h
		school.cpp
		school.h
		shanty.cpp
		shanty.h
		solar_power.cpp
		solar_power.h
		substation.cpp
		substation.h
		tip.cpp
		tip.h
		track_road_rail.cpp
		track_road_rail.h
		university.cpp
		university.h
		water.cpp
		water.h
		waterwell.cpp
		waterwell.h
		windmill.cpp
		windmill.h
		windpower.cpp
		windpower.h
		)

add_library(LinCity::lib_modules ALIAS lincity_lib_modules)

target_link_libraries(lincity_lib_modules
		PUBLIC
		tinygettext
		LinCity::lib
)

target_include_directories(lincity_lib_modules PRIVATE ${PHYSFS_INCLUDE_DIR})
target_link_libraries(lincity_lib_modules PRIVATE ${PHYSFS_LIBRARY})

include_directories(.)

=== debian/changelog ===
lincity-ng (2.12.0-2build1) questing; urgency=medium

  * No-change rebuild for libxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 21 May 2025 08:17:47 +0200

lincity-ng (2.12.0-2) unstable; urgency=medium

  * Team upload.
  * Add d/clean (Closes: #1047945)
  * Issue in FluidSynth has been fixed (Closes: #1096210)

  TODO: new upstream version needs libxml++ 5.0

 -- Alexandre Detiste <tchet@debian.org>  Sun, 09 Mar 2025 11:52:06 +0100

lincity-ng (2.12.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.12.0

  [ Fabio Pedretti ]
  * remove unneeded FTBFS patch

 -- Alexandre Detiste <tchet@debian.org>  Thu, 14 Nov 2024 00:18:23 +0100

=== debian/control ===
--- 
+++ 
@@ -3,33 +3,34 @@
 Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders:
- Markus Koschany <apo@debian.org>
+ Markus Koschany <apo@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
  libphysfs-dev,
+ libsdl2-dev,
  libsdl2-gfx-dev,
  libsdl2-image-dev,
  libsdl2-mixer-dev,
  libsdl2-ttf-dev,
- libsdl2-dev,
  libxml2-dev,
  libxslt1-dev,
  pkgconf,
  xsltproc,
- zlib1g-dev
+ zlib1g-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/games-team/lincity-ng.git
 Vcs-Browser: https://salsa.debian.org/games-team/lincity-ng
 Homepage: https://github.com/lincity-ng/lincity-ng/
+X-Style: black
 
 Package: lincity-ng
 Architecture: any
 Depends:
  lincity-ng-data (= ${source:Version}),
  ${misc:Depends},
- ${shlibs:Depends}
+ ${shlibs:Depends},
 Description: City simulator game with polished graphics
  LinCity-NG is a City Simulation Game. It is a polished and improved
  version of the old LinCity game:
@@ -45,12 +46,13 @@
 Package: lincity-ng-data
 Architecture: all
 Multi-Arch: foreign
-Breaks: lincity-ng (<< 2.10.2-1~)
+Breaks:
+ lincity-ng (<< 2.10.2-1~),
 Depends:
  fonts-dejavu,
- ${misc:Depends}
+ ${misc:Depends},
 Suggests:
- lincity-ng
+ lincity-ng,
 Description: Media files for the city simulator game LinCity-NG
  LinCity-NG is a City Simulation Game. It is a polished and improved
  version of the old LinCity game:

## lincity-ng 2.14.2

=== debian/changelog ===
lincity-ng (2.14.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Sébastien Noel <sebastien@twolife.be>  Mon, 23 Feb 2026 09:32:18 +0100

=== debian/control ===
--- 
+++ 
@@ -1,25 +1,24 @@
 Source: lincity-ng
 Section: games
-Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders:
  Markus Koschany <apo@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
- libphysfs-dev,
+ libfmt-dev,
  libsdl2-dev,
  libsdl2-gfx-dev,
  libsdl2-image-dev,
  libsdl2-mixer-dev,
  libsdl2-ttf-dev,
  libxml2-dev,
+ libxml++-5.0-dev,
  libxslt1-dev,
  pkgconf,
  xsltproc,
  zlib1g-dev,
-Rules-Requires-Root: no
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Git: https://salsa.debian.org/games-team/lincity-ng.git
 Vcs-Browser: https://salsa.debian.org/games-team/lincity-ng
 Homepage: https://github.com/lincity-ng/lincity-ng/

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/pkg-info.mk

%:
	dh $@

# BUG: FULL_PROJECT_VERSION & CMAKE_INSTALL_APPDATADIR
#      are not taken into account (BINDIR well)
override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_BINDIR=/usr/games/ \
		-DFULL_PROJECT_VERSION=$(DEB_VERSION) \
		-DCMAKE_INSTALL_APPDATADIR=/usr/share/games

execute_after_dh_auto_install:
	$(RM) debian/tmp/usr/share/doc/lincity-ng/COPYING.txt
